(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.logsnap = {}));
}(this, (function (exports) { 'use strict';

	function createCommonjsModule(fn, basedir, module) {
		return module = {
			path: basedir,
			exports: {},
			require: function (path, base) {
				return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
			}
		}, fn(module, module.exports), module.exports;
	}

	function commonjsRequire () {
		throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
	}

	var _typeof_1 = createCommonjsModule(function (module) {
	function _typeof(obj) {
	  "@babel/helpers - typeof";

	  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
	    module.exports = _typeof = function _typeof(obj) {
	      return typeof obj;
	    };
	  } else {
	    module.exports = _typeof = function _typeof(obj) {
	      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
	    };
	  }

	  return _typeof(obj);
	}

	module.exports = _typeof;
	});

	/*! *****************************************************************************
	Copyright (c) Microsoft Corporation.

	Permission to use, copy, modify, and/or distribute this software for any
	purpose with or without fee is hereby granted.

	THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
	REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
	INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
	LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
	OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
	PERFORMANCE OF THIS SOFTWARE.
	***************************************************************************** */

	var __assign = function() {
	    __assign = Object.assign || function __assign(t) {
	        for (var s, i = 1, n = arguments.length; i < n; i++) {
	            s = arguments[i];
	            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
	        }
	        return t;
	    };
	    return __assign.apply(this, arguments);
	};

	function __spreadArrays() {
	    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
	    for (var r = Array(s), k = 0, i = 0; i < il; i++)
	        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
	            r[k] = a[j];
	    return r;
	}

	/**
	 * Runs forEach on each key/value pair of the value, passing in the key as the first
	 * argument and the value as the second argument on each iteration
	 * @param { object } value
	 * @param { function } callback - Callback function to run on each key/value entry
	 */

	function forEachEntries(value, callback) {
	  if (value && _typeof_1(value) === 'object') {
	    Object.entries(value).forEach(function (_a) {
	      var k = _a[0],
	          v = _a[1];
	      return callback(k, v);
	    });
	  }
	}

	var _color = {
	  blue: '#0047ff',
	  cyan: '#00D8C2',
	  gold: '#c4a901',
	  green: '#00b406',
	  grey: '#828282',
	  hotpink: '#e50087',
	  info: '#3498db',
	  magenta: 'magenta',
	  orange: '#FF5722',
	  red: '#ec0000',
	  salmon: 'salmon',
	  teal: '#20B2AA',
	  yellow: '#CCCD17'
	};

	var logger = function () {
	  var state = {
	    disabled: false,
	    cache: {},
	    cacheBackup: {}
	  };
	  var _bold = 'font-weight:bold;';

	  var _noop = function _noop() {
	    return function () {};
	  };

	  var cons = state.disabled ? _noop : window.console;

	  function get(id) {
	    var _innerState = {
	      id: id,
	      func: ''
	    };
	    var o = {
	      func: _func,

	      get id() {
	        return _innerState.id;
	      },

	      set id(id) {
	        _innerState['id'] = id;
	      },

	      log: cons.log.bind(cons, "[" + id + "] %s")
	    };

	    var _stringifyArgs = function _stringifyArgs(_a) {
	      var _b = _a === void 0 ? {} : _a,
	          color = _b.color,
	          data = _b.data;

	      var msg = "[" + _innerState.id + "]";
	      if (_innerState.func) msg += "[" + _innerState.func + "]";
	      var args = ["%c" + msg + " %s", "color:" + (color || _color.grey) + ";" + _bold];

	      if (args[1].includes(_color.grey)) {
	        // Remove the unnecessary bold effect to make it easier on the eyes
	        args[1] = args[1].replace(_bold, 'font-weight:100;');
	      }

	      if (data) args.push(data);
	      return args;
	    };

	    var _refreshLoggers = function _refreshLoggers() {
	      forEachEntries(_color, function (colorKey, color) {
	        var _a;

	        o[colorKey] = state.disabled ? _noop : (_a = cons.log).bind.apply(_a, __spreadArrays([cons], _stringifyArgs({
	          color: color
	        })));
	      });
	    };

	    function _func(name) {
	      if (name) _innerState['func'] = name;else _innerState['func'] = '';
	      if (!state.disabled) _refreshLoggers();
	      return this;
	    }

	    _refreshLoggers();

	    return o;
	  }

	  return {
	    create: function create(id) {
	      var cached = state.cache[id];
	      var logger;

	      if (!cached) {
	        logger = get(id);
	        state.cache[id] = logger;
	      } else {
	        logger = cached;
	      }

	      return logger;
	    },
	    enable: function enable() {
	      state.disabled = false; // cache = { ...cacheBackup }
	      // cacheBackup = {}

	      return this;
	    },
	    disable: function disable() {
	      state['disabled'] = true;
	      state['cacheBackup'] = __assign({}, state.cache);
	      Object.values(state.cache).forEach(function (value) {
	        Object.keys(value).forEach(function (k) {
	          value[k] = _noop;
	        });
	      });
	      return this;
	    }
	  };
	}();

	exports._color = _color;
	exports.default = logger;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.js.map
